unit About;

interface

uses WinTypes, WinProcs, Messages, SysUtils, Classes, Controls, Forms, Menus,
  Graphics,  DsgnIntf, StdCtrls, ExtCtrls;

type
  TFAbout = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Panel6: TPanel;
    Panel7: TPanel;
    Panel8: TPanel;
    Panel9: TPanel;
    Panel10: TPanel;
    Panel11: TPanel;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TAboutBox = class(TComponent)
  private
    FProductName             : String[100];
    FVersion                 : String[100];
    FCopyright               : String[100];
    function  GetProductName : String;
    function  GetVersion     : String;
    function  GetCopyright   : String;
    procedure SetProductName (const AStr: String);
    procedure SetVersion     (const AStr: String);
    procedure SetCopyright   (const AStr: String);
  public
    constructor Create(AOwner: TComponent); override;
    function Execute: Boolean; virtual;
  published
    property ProductName : String read GetProductName write SetProductName;
    property Version     : String read GetVersion     write SetVersion;
    property Copyright   : String read GetCopyright   write SetCopyright;
  end;

procedure Register;

implementation

{$R *.DFM}

uses Consts;

{------------- TAboutBox begin ------------------------------------------------------}

constructor TAboutBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FCopyright := ' 1995 The Software Factory';
end;

function TAboutBox.Execute: Boolean;
var  FAbout: TFAbout;
begin

  try
    FAbout:=  TFAbout.Create(Application);
  except
    on E: Exception do begin
      MessageBeep(0);
      Exit;
    end;
  end;

  FAbout.Label19.Caption:= FProductName;
  FAbout.Label20.Caption:= FVersion;
  FAbout.Label21.Caption:= FCopyright;

  with FAbout do begin
    try     ShowModal;
    Finally Free;
    end;
  end;

end;

function TAboutBox.GetProductName: String;
begin
  Result := FProductName;
end;

function TAboutBox.GetVersion: String;
begin
  Result := FVersion;
end;

function TAboutBox.GetCopyright: String;
begin
  Result := FCopyright;
end;

procedure TAboutBox.SetProductName(const AStr: String);
begin
  FProductName:= AStr;
end;

procedure TAboutBox.SetVersion(const AStr: String);
begin
  FVersion:= AStr;
end;

procedure TAboutBox.SetCopyright(const AStr: String);
begin
  FCopyright:= AStr;
end;

{------------- TAboutBox end   ------------------------------------------------------}

procedure Register;
begin
  RegisterComponents('CMS35', [TAboutBox]);
end;

procedure TFAbout.FormCreate(Sender: TObject);
type
  FlagSet = set of 120..135;
var
  Flgs : FlagSet;
  l    : LongInt;
  s    : String;
  Win  : Word;
  DOS  : Word;
begin
{--------- Version of Windows ----------}
  Label7.Caption:= IntToStr(HiByte(LoWord(GetVersion)));

{--------- Version of DOS -------------}
  Label8.Caption:= IntToStr(HiByte(HiWord(GetVersion)));

{---------- Procesor --------------}

  l:= GetWinFlags;
  Flgs:= FlagSet(Word(l));
  s:= 'unknown';
  if 121 in Flgs then s:= '286';
  if 122 in Flgs then s:= '386';
  if 123 in Flgs then s:= '486 or Pentium';
  Label11.Caption:= s;

{---------- Mode --------------}

  s:= 'unknown';
  if 124 in Flgs then s:= 'Standard';
  if 125 in Flgs then s:= '386 Enhanced';
  Label9.Caption:= s;

{---------- Coprocesor --------------}

  if 130 in Flgs then s:= 'Present'
                 else s:= 'Not present';
  Label12.Caption:= s;

{--------- Memory -------------}

  l:= GetFreeSpace(0) div 1024;
  Label10.Caption:= IntToStr(l) + 'KB';

{--------- GDI Resources -------------}

  l:= GetFreeSystemResources(gfsr_GDIResources);
  Label16.Caption:= IntToStr(l) + '%';
  Panel9.Width:= (Panel9.Width * l) div 100;

{--------- User Resources -------------}

  l:= GetFreeSystemResources(gfsr_UserResources);
  Label17.Caption:= IntToStr(l) + '%';
  Panel10.Width:= (Panel10.Width * l) div 100;

{--------- Disk space -------------}

  l:= (DiskFree(0) div 10240) div (DiskSize(0) div 1024000);
  Label18.Caption:= IntToStr(DiskFree(0) div 1024000) +
                    +' MB (' +
                    + IntToStr(l) +
                    + '%)';
  Panel11.Width:= (Panel11.Width * l) div 100;

end;

procedure TFAbout.Button1Click(Sender: TObject);
begin
  Close;
end;

end.
 